##################
## LAB QTL
require(qtlnet)
setwd("~/Documents/TEACHING/2019 Course AUS/Labs/")
load(file = "Lab 4 Data QTL.Rdata")

## QTL mapping Haley-Knott Regression
data = calc.genoprob(data, step = 1, error.prob = 0.001)
fit = scanone(data, pheno.col = 1:5, method = "hk")

par(mfrow = c(1,5))
for(i in 1:5){
plot(fit, lodcolumn = i, ylab = "lod", col = "blue")}

## QTL mapping: Unconditional versus Conditional Mapping 
par(mfrow = c(2,5)) 
unCond= paste("Y", 1:5, sep = "")
for (i in 1:5) {
	plot(fit, lodcolumn = i, main = unCond[i], ylab = "lod")}
    plot(fit, lodcolumn = 1, main = unCond[1], ylab = "lod")
    cond = c("Y1", "Y2 | Y1", "Y3 | Y2", "Y4 | Y2", "Y5 | Y3, Y4")
    pheno.parents <- list(NULL, 1, 2, 2, c(3, 4))
    for (i in 2:5) {
    cross = calc.genoprob(data, step = 1, error.prob = 0.001)
    CondScan = scanone(data, pheno.col = i, method = "hk",
               addcov = cross$pheno[,pheno.parents[[i]]])
    
    plot(CondScan, main = cond[i], ylab = "lod")
}

## Generate Object with QTLs

cross = sim.geno(cross, n.draws = 1)
allQTLs = vector(mode = "list", length = 5)
markers = allQTLs
names(allQTLs) = paste("y", 1:5, sep = "")
names(markers) = names(allQTLs)

for (i in 1:5) {
	aux = summary(fit[,c(1,2,i+2)], thr = 3.00)
	markers[[i]] = find.marker(cross, chr = aux[, 1], pos = aux[, 2])
	allQTLs[[i]] = makeqtl(cross, chr = aux[, 1], pos = aux[, 2])}
	
allQTLs
	
## QDG Algorithm

outQDG = qdg(cross = cross, phenotype.names = paste("y", 1:5, sep = ""),
marker.names = markers, QTL = allQTLs, alpha = 0.01, n.qdg.random.starts = 10,
addcov = NULL,intcov = NULL,skel.method = "pcskel")

outQDG$UDG
outQDG$DG

plot(graph.qdg(outQDG, include.qtl = FALSE))
plot(graph.qdg(outQDG, include.qtl = TRUE))

## QTLnet algorithm.

outQTLnet = mcmc.qtlnet(cross = cross,pheno.col = 1:5,threshold = 3.00,
addcov = NULL,intcov = NULL,nSamples = 5000,thinning = 3,max.parents = 4,M0 = NULL,
burnin = 0.2,method = "hk",random.seed = 3,init.edges = 0,saved.scores = NULL,
rev.method = "nbhd",verbose = TRUE)

options(warn=-1)
summary(outQTLnet)
print(outQTLnet)
loci.qtlnet(outQTLnet)
